﻿using UnityEngine;
using System.Collections;
using System;
using System.Collections.Generic;


public class MotherShip : MonoBehaviour {


	[SerializeField]
	private int screenH;
	private Transform thisObj;



	// Use this for initialization
	void Awake () {
		thisObj = this.gameObject.transform;
		thisObj.rigidbody2D.gravityScale = 0;
		StartCoroutine ("StartUp");
	}

	IEnumerator StartUp(){
		yield return new WaitForSeconds (3);
		thisObj.rigidbody2D.gravityScale = 0.01f;
		Debug.Log ("StartUp");
		StartCoroutine ("GravUp");
	}

	IEnumerator GravUp(){
		while (true) {
			if(thisObj.position.y >= 5.0f){
				thisObj.rigidbody2D.gravityScale += 0.001f;
			}
			yield return new WaitForSeconds(1);
		}
	}

	void Update(){


		Vector3 viewPos = Camera.main.WorldToViewportPoint (this.transform.position);

		viewPos.x = Mathf.Clamp01 (viewPos.x);
		viewPos.y = Mathf.Clamp01 (viewPos.y);
		this.transform.position = Camera.main.ViewportToWorldPoint (viewPos);

	}




}
