﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;



public class Satellite : MonoBehaviour {

	public Transform satPos;
	public LineRenderer lineR;
	public Material lineMat;
	public GameObject curTarg;
	public GameObject curSat;
	public Shield lastPlayer;
	public CircleCollider2D cCollider;

	public SatState sState;
	public GameObject playerRef;
	public GameObject playerRefTwo;
	public float tetherTime;



	public enum SatState { Target, Fire, Player};
	
	// Use this for initialization
	void Awake () {
		lineR = GetComponent<LineRenderer> ();
		cCollider = GetComponent<CircleCollider2D> ();
		lineR.SetWidth(0.2f,0.2f);
		//lineR.renderer.material = lineMat;
		lineR.SetVertexCount(2);
		SpawnManager.activeSats.Add (this.gameObject);
		sState = new SatState();
		sState = SatState.Target;
		satPos = gameObject.transform;
		playerRef = GameObject.FindWithTag("Player");


	}
	
	// Update is called once per frame
	void Update () {

		switch(sState){

		case SatState.Target:
			if(curTarg == null){
				Target();
			}
			break;
		case SatState.Player:
			//TargetPlayer ();
			if(curTarg.tag == "Player"){
				sState = SatState.Fire;
			}
			break;
		case SatState.Fire:
			FireActive();
			break;

		}

		if (satPos.position.x <= -10) {
			//gameObject.SetActive(false);
			gameObject.Recycle();
			SpawnManager.instance.numSats -= 1;
		}

	}

	void Target(){
		var ind = Random.Range(0,SpawnManager.activeSats.Count);
		var obj = SpawnManager.activeSats[ind].gameObject;
		if(obj != null){
			curTarg = obj;
			sState = SatState.Fire;
		}else { 
			Target ();
		}

	}

	void TargetPlayer(GameObject player){
		curTarg = player;
		lastPlayer = curTarg.GetComponent<Shield> ();
		if (!lastPlayer.lockedOn.Contains (gameObject)) {
			lastPlayer.lockedOn.Add (gameObject);
		}
	}

	IEnumerator SwitchState(){

		yield return new WaitForSeconds (tetherTime);
		if (lastPlayer != null && lastPlayer.lockedOn.Contains (gameObject)) {
			lastPlayer.lockedOn.Remove (gameObject);
			lastPlayer = null;
		}
		curTarg = null;
		lineR.enabled = false;
		sState = SatState.Target;

	}

	void FireActive(){
		lineR.enabled = true;
		LineCheck ();
		if(curTarg != null && curTarg.tag == "Player"){
			lineR.SetPosition (0, cCollider.bounds.center);
			lineR.SetPosition (1, curTarg.GetComponent<CircleCollider2D>().bounds.center);
			StartCoroutine("SwitchState");

		}else if(curTarg!= null && curTarg.tag != "Player"){

			lineR.SetPosition (0, cCollider.bounds.center);
			lineR.SetPosition (1, curTarg.GetComponent<CircleCollider2D>().bounds.center);

		}
		//lineR.enabled = true;
	}

	void LineCheck(){
		RaycastHit2D hit = Physics2D.Linecast(new Vector2(satPos.position.x,satPos.position.y), new Vector2(curTarg.transform.position.x,curTarg.transform.position.y));
		Physics2D.raycastsStartInColliders = false;
		Debug.DrawLine (new Vector2 (satPos.position.x, satPos.position.y), new Vector2 (curTarg.transform.position.x, curTarg.transform.position.y));
		if(hit.collider != null){
			if(hit.collider.tag == "Player"){
				TargetPlayer (hit.collider.gameObject);
				sState = SatState.Player;
			}
		}
	}


}
