using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Shield : MonoBehaviour {

	public float speed =1.0f;

	public Vector3 tempVector2;
	public Vector3 inputRotation2;
	public float targetAngle;
	public Quaternion rotation;

	public LineRenderer lineR;
	public Material playerLineMat;
	public CircleCollider2D cCollider;
	public Transform forwardTarg;

	public string axisName1 = "RStickX";
	public string axisName2 = "RStickY";
	public float hMod;
	private bool active = false;

	public Material[] mats;
	public float dps;

	public List<GameObject> lockedOn = new List<GameObject>();
	// Use this for initialization
	void Start () {
		cCollider = GetComponent<CircleCollider2D> ();
		lineR = GetComponent<LineRenderer> ();
		lineR.SetWidth(0.2f,0.2f);
		lineR.renderer.material = playerLineMat;
		lineR.SetVertexCount(2);
	}
	public RaycastHit2D hit;
	private bool switchStart = false;
	// Update is called once per frame
	void FixedUpdate () {


				// Get direction analogue stick is pointed to
				tempVector2 = new Vector3 (Input.GetAxis (axisName1), Input.GetAxis (axisName2), 0);

				// Set rotation
				inputRotation2 = tempVector2;
		
				// Set the object's rotation
				//transform.rotation = Quaternion.LookRotation(inputRotation);
				tempVector2.Normalize ();



				//transform.LookAt(transform.position + Vector3(tempVector2), -Vector3.forward);

		
				//if (tempVector != Vector2.zero)
				//{
				// calculates the angle we should turn towards, - 90 makes the sprite rotate
				targetAngle = Mathf.Atan2 (tempVector2.y, tempVector2.x) * Mathf.Rad2Deg;
				transform.rotation = Quaternion.Euler (new Vector3 (0, 0, -targetAngle));
				// actually rotates the sprite using Slerp (from its previous rotation, to the new one at the designated speed.
				//transform.rotation = Quaternion.Slerp (transform.rotation, Quaternion.Euler (0, 0, targetAngle), speed * Time.deltaTime);
				//}

				//transform.up = tempVector2;

				if (lockedOn.Count > 0) {
						active = true;
						dps = lockedOn.Count;
						lineR.SetWidth (0.2f * dps, 0.2f * dps);
						lineR.SetPosition (0, cCollider.bounds.center);
						lineR.SetPosition (1, forwardTarg.position);
						if(!switchStart){
							StartCoroutine("SwitchMats");
							switchStart = true;
						}
		
						hit = Physics2D.Linecast (transform.position, forwardTarg.position);
						Physics2D.raycastsStartInColliders = false;
						Debug.DrawLine (transform.position, forwardTarg.position);
						if (hit.collider != null) {
								if (hit.collider.tag == "Asteroid") {
										var temp = hit.collider.GetComponent<Asteroids> ();
										temp.hp -= dps * 3f;
								}
								if (hit.collider.tag == "Mothership") {
										//Debug.Log ("Hit Mother");
//					var temp = hit.collider.GetComponent<Rigidbody2D>();
//					temp.AddForce(Vector2.one * hMod,ForceMode2D.Impulse);
										//hit.collider.rigidbody2D.AddForce();
										hit.collider.rigidbody2D.AddForce (new Vector2 (0, 1) * 2.0f, ForceMode2D.Impulse);

								}
						}
				} else {
					StopCoroutine("SwitchMats");
					lineR.enabled = false;
					switchStart = false;
					active = false;
				}
		}

		IEnumerator SwitchMats(){
			while(active){
			lineR.enabled = true;
			lineR.renderer.material = lineR.renderer.materials[Random.Range(0,lineR.renderer.materials.Length - 1)];
			yield return new WaitForEndOfFrame();
			}
		}




		//Assumes you're looking down the z axis and that you are looking down on the avatar
		//transform.LookAt(transform.position + Vector3(rv, 0, rh), -Vector3.up);
	}
		

