﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SpawnManager : MonoBehaviour {

	private static SpawnManager _instance;

	public static SpawnManager instance { 
		get { 
			if (_instance == null)
					_instance = GameObject.FindObjectOfType<SpawnManager> ();
					return _instance;
			}
	}

	public static List<GameObject> activeSats = new List<GameObject>();
	public GameObject satPrefab;
	public GameObject asterPrefab;

	public Transform[] spawnLocs;
	public Transform[] astSpawns;

	public int spawnRate;
	public float spawnX;
	public float spawnYmax;
	public float spawnYmin;

	public int maxSats;
	public int numSats;

	public int maxAsts;
	public int numAsts;

	// Use this for initialization
	void Start () {
	
		satPrefab.CreatePool (10);
		asterPrefab.CreatePool (10);
		numSats = 0;
		StartCoroutine ("Spawner");
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	IEnumerator Spawner(){

		while (true) {
			SpawnSat();
			SpawnAst();
			yield return new WaitForSeconds(spawnRate);
		}
	}

	void SpawnSat(){
		if (numSats < maxSats) {
			satPrefab.Spawn (GetSpawnLoc());
			satPrefab.name = "SatPrefab " + numSats.ToString();
			numSats += 1;
		}
	}

	void SpawnAst(){
		if (numAsts < maxAsts) { 
			asterPrefab.Spawn(astSpawns[Random.Range(0,astSpawns.Length)]);
			numAsts +=1;
		}
	}

	public void SatDead(){
		numSats -= 1;
	}

	Vector2 GetSpawnLoc(){
		var index = Random.Range (0, spawnLocs.Length);
		if (CheckSpawn (spawnLocs [index])) {
						return new Vector2 (spawnLocs [index].transform.position.x, spawnLocs [index].transform.position.y);
				} else { 
						var indexa = Random.Range (0, spawnLocs.Length);
					
					
						return new Vector2 (spawnLocs [indexa].transform.position.x, spawnLocs [indexa].transform.position.y);	
						
				}
	}

	bool CheckSpawn(Transform loc){

		Ray ray = new Ray ();
		if (Physics.SphereCastAll (ray, 5f) != null) {
						return false;
				} else 
						return true;


	}
	
}
